const
  nSuff:array[0..8] of string[7] =
          ('','','줥','','','','','','');
  nRoot:array[0..15] of string[6]=
          ('','','','','','','','ᥬ','ᥬ','',
           '','','','ﭮ','','ப');

function dMake(a:char;j:byte;t:boolean):string;
var c,b:byte;
begin
  c:=ord(a)-48;
  case j of
    0: begin
        if (c=2) or (c=4) or (c=0) then inc(c,10);
        if c=10 then b:=3 else b:=0;
      end;
    1: case c of
        1: begin c:=0; b:=7; end;
        2: begin c:=12; b:=6; end;
        3,4: b:=5;
        else b:=1;
      end;
    2: case c of
        2,3: b:=4;
        4: begin c:=15; b:=8; end;
        9: begin c:=13; b:=7; end;
        else b:=2;
      end;
    3: begin
        if c<5 then b:=8 else b:=3;
        if (c<3) and t then inc(c,10);
      end;
  end;
  dMake:=nRoot[c]+nSuff[b]+' ';
end;

function nMake(var s:string;t:boolean):string;
var s1:string;
    j,k:byte;
begin
  s1:='';
  for j:=1 to 3 do begin
    if (s[2]='1') and (j=2) then begin
      k:=0; j:=3;
    end else
      k:=j;
    if ((s[j]<>'0') or (k=0)) and (s[j]<>' ') then
      s1:=s1+dMake(s[j],k,t);
  end;
  nMake:=s1;
end;

const
  uSuff:array[1..8] of string[2]=('','','','','','','','');
  uRoot:array[1..5] of string[8]=('㡫','','','',
                                  'ਫ');

function uMake(var s:string;u:byte):string;
var b:byte;
begin
  uMake:='';
  if (Trim(s)='') or (s='000') then exit;
  if s[2]='1' then begin
    b:=3;
  end else begin
    b:=ord(s[3])-48;
    if (b>=5) or (b=0) then
      b:=3
    else
      if (b>2) then
        b:=2;
  end;
  if u=1 then
    inc(b,5)
  else
    if u>2 then
      inc(b,2);
  uMake:=uRoot[u]+uSuff[b]+' ';
end;

function Sum2text(Sum:comp):string;
var s1,s2,s3:string;
    i:byte;
    j:word;
    k:integer;
begin
  if Sum=0 then begin
    Sum2text:=' 㡫 00 .';
    exit;
  end;
  Str(Sum:17:0,s3);
  s1:=copy(s3,16,2)+' .';
  for i:=1 to 5 do begin
    s2:=copy(s3,(5-i)*3+1,3);
    if Trim(s2)<>'' then begin
      Val(s2,j,k);
      if j>0 then
        s1:=nMake(s2,(i=2))+uMake(s2,i)+s1;
    end;
  end;
  s1[1]:=UpCaseR(s1[1]);
  Sum2text:=s1;
end;

function lSplit(var s:string;l:byte):string;
var i:byte;
begin
  if l>=length(s) then begin
    lSplit:=s;
    s:='';
    exit;
  end;
  i:=l;
  while (i>0) and (s[i]<>' ') do dec(i);
  if i=0 then i:=l;
  lSplit:=copy(s,1,i);
  s:=copy(s,i+1,length(s)-i);
end;



